reservation/urls.py
from django.urls import path

from reservation import views

urlpatterns = [
    # homepage
    path('', views.HomePage.as_view(), name='homepage'),

    # classroom paths
    path('classes/', views.ClassroomList.as_view(), name='classroom-list'),
    path('classes/create/', views.CreateClassroom.as_view(), name='classroom-create'),
    path('classes/<int:pk>/', views.ClassroomDetail.as_view(), name='classroom-detail'),
    path('classes/<int:id>/event/', views.EventClassroomList.as_view(), name='classroom-events'),
    path('classes/<int:id>/event/<int:pk>/', views.EventDetail.as_view(), name='classroom-event'),
    path('classes/<int:id>/event/<int:pk>/update/', views.UpdateEvent.as_view(), name='classroom-event-update'),
    path('classes/<int:id>/event/<int:pk>/delete/', views.DeleteEvent.as_view(), name='classroom-event-delete'),
    path('classes/<int:id>/event/<int:pk>/equipment/', views.AddEquipment.as_view(), name='event-equipment'),
    path('classes/<int:pk>/create/', views.CreateEvent.as_view(), name='classroom-event-create'),
    path('classes/<int:pk>/update/', views.UpdateClassroom.as_view(), name='classroom-update'),
    path('classes/<int:pk>/delete/', views.DeleteClassroom.as_view(), name='classroom-delete'),

    # equipment paths
    path('equipments/', views.EquipmentListView.as_view(), name='equipment-list'),
    path('equipments/create/', views.CreateEquipment.as_view(), name='equipment-create'),
    path('equipments/<int:pk>/', views.EquipmentDetailView.as_view(), name='equipment-detail'),
    path('equipments/<int:pk>/update/', views.UpdateEquipment.as_view(), name='equipment-update'),
    path('equipments/<int:pk>/delete/', views.DeleteEquipment.as_view(), name='equipment-delete'),

    # campus paths
    path('campus/', views.CampusList.as_view(), name='campus-list'),
    path('campus/create/', views.CreateCampus.as_view(), name='campus-create'),
    path('campus/<int:pk>/', views.CampusDetail.as_view(), name='campus-detail'),
    path('campus/<int:pk>/update/', views.UpdateCampus.as_view(), name='campus-update'),
    path('campus/<int:pk>/delete/', views.DeleteCampus.as_view(), name='campus-delete'),

    # event paths
    path('event/', views.UnauthorizedEvents.as_view(), name='event-list'),
    path('event/<int:pk>/', views.UnauthorizedEventDetail.as_view(), name='event-detail'),
    path('event/<int:pk>/update/', views.UpdateUnauthorizedEvent.as_view(), name='event-update'),
    path('event/<int:pk>/delete/', views.DeleteUnauthorizedEvent.as_view(), name='event-delete'),
    path('event/<int:pk>/authorize/', views.Authorize.as_view(), name='authorize'),

    # pre-schedule and reservate
    path('classes/<int:pk>/preschedule/', views.PreSchedule.as_view(), name='pre-schedule'),
    path('classes/<int:pk>/reservate/', views.AddMultipleEvents.as_view(), name='reservate'),

    path('login/', views.LoginView.as_view(), name='login'),
    path('logout/', views.LogoutView.as_view(), name='logout')
]

settings/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from settings import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('reservation/v1/', include('reservation.urls'))
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

reservation/models.py
from abc import ABC

from django.contrib.auth.models import AbstractUser, BaseUserManager
from django.db import models


class UserManager(BaseUserManager):
    use_in_migrations = True

    def _create_user(self, email, password, **extra_fields):
        if not email:
            raise ValueError("O email é obrigatório")

        email = self.normalize_email(email)

        user = self.model(email=email, username=email, **extra_fields)
        user.set_password(password)
        user.save(using=self._db)

        return user

    def create_user(self, email, password=None, **extra_fields):
        return self._create_user(email, password, **extra_fields)

    def create_superuser(self, email, password, **extra_fields):
        extra_fields.setdefault('is_superuser', True)
        extra_fields.setdefault('is_staff', True)

        if extra_fields.get('is_superuser', True) is not True:
            raise ValueError('Superuser precisa ser superuser')
        if extra_fields.get('is_staff', True) is not True:
            raise ValueError('Superuser precisa ser staff')

        return self._create_user(email, password, **extra_fields)


class CustomUser(AbstractUser):
    possible_choices = [
        ("common", "common"),
        ("dean", "dean"),
        ("prefecture", "prefecture"),
        ("director", "director"),
        ("teacher", "teacher")
    ]
    email = models.EmailField('Email', unique=True)
    role = models.CharField(max_length=255, null=False, default="common", choices=possible_choices, blank=False)

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['first_name', 'last_name', 'role']

    def __str__(self):
        return self.email

    objects = UserManager()


class Campus(models.Model):
    class Meta:
        default_permissions = ()

    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name


class ClassRoom(models.Model):
    class Meta:
        default_permissions = ()

    capacity = models.IntegerField(default=30)
    institution = models.ForeignKey(Campus, on_delete=models.CASCADE)

    def __str__(self):
        return str(self.pk)


class Equipment(models.Model):
    name = models.CharField(max_length=200, null=False, blank=False)
    brand = models.CharField(max_length=200, null=False, blank=False)
    serial_number = models.IntegerField(null=False, blank=False, unique=True)

    def __str__(self):
        return self.name


class Event(models.Model):
    duration = [
        (2, "2 horas"),
        (4, "4 horas"),
        (6, "6 horas"),
        (8, "8 horas"),
        (10, "10 horas"),
        (12, "12 horas")
    ]

    possible_states = [
        ("Confirmado", "Confirmado"),
        ("Aguardando confirmação", "Aguardando confirmação"),
    ]

    name = models.CharField(max_length=255, null=False, blank=False)
    date = models.DateField(blank=False, null=False)
    time = models.TimeField(blank=False, null=False)
    duration = models.IntegerField(choices=duration, blank=False, null=False)
    classroom = models.ForeignKey(ClassRoom, on_delete=models.CASCADE)
    responsible = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    status = models.CharField(max_length=255, null=False, default="Confirmado", choices=possible_states, blank=False)


class EventEquipment(models.Model):
    equipment = models.ForeignKey(Equipment, on_delete=models.CASCADE, blank=False, null=False)
    event = models.ForeignKey(Event, on_delete=models.CASCADE, blank=False, null=False)

reservation/forms.py
from django.contrib.auth.forms import UserCreationForm, UserChangeForm
from django import forms

from .models import *


class CustomUsuarioCreateForm(UserCreationForm):

    class Meta:
        model = CustomUser
        fields = ('first_name', 'last_name', 'role')
        labels = {'username': 'Username/E-mail', 'role': 'role'}

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data["password1"])
        user.email = self.cleaned_data["username"]
        if commit:
            user.save()
        return user


class CustomUsuarioChangeForm(UserChangeForm):

    class Meta:
        model = CustomUser
        fields = ('first_name', 'last_name', 'role')


class LoginForm(forms.Form):
    username = forms.CharField(label='Usuário')
    password = forms.CharField(label='Senha', widget=forms.PasswordInput)


class CreateEquipmentForm(forms.ModelForm):
    class Meta:
        model = Equipment
        fields = ['name', 'brand', 'serial_number']


class AddEquipmentForm(forms.ModelForm):
    class Meta:
        model = EventEquipment
        fields = ['equipment']


class UpdateEquipmentForm(forms.ModelForm):
    class Meta:
        model = Equipment
        fields = ['name']


class ClassesForm(forms.ModelForm):
    class Meta:
        model = ClassRoom
        fields = ['capacity', 'institution']


class UpdateClassesForm(forms.ModelForm):
    class Meta:
        model = ClassRoom
        fields = ['capacity', 'institution']


class EventForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['name', 'date', 'time', 'duration', 'classroom']


class CreateEventForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['name', 'date', 'time', 'duration']


class PreScheduleForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['name', 'date', 'time', 'duration']


class AddMultipleEventsForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['name', 'date', 'time', 'duration']

    limit_date = forms.DateField()


class UpdateEventsForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['date', 'time', 'duration']


class CreateCampusForm(forms.ModelForm):
    class Meta:
        model = Campus
        fields = ['name']


class UpdateCampusForm(forms.ModelForm):
    class Meta:
        model = Campus
        fields = ['name']

reservation/templates/reservation/event/equipment_form.html
{% extends "../base.html" %} 
{% block header %}
Reservas - Adicionar Equipamento
{% endblock header %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Equipments.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">ADICIONAR EQUIPAMENTO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text"></span>
        {{ form }}
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/event/event_authorize.html
{% extends "../base.html" %} 
{% block header %}
Reservas - Atualizar Evento
{% endblock header %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Pre_Agendar.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">ATUALIZAR EVENTO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <button class="delete-button">
        <span>Autorizar</span>
    </button>
  </form>
  <form action="{% url 'event-delete' event.id %}" method="post" style="display: inline;">
    {% csrf_token %}
    <input type="hidden" name="event_id" value="{{ object.pk }}"/>
    <button type="submit" class="delete-button" style="background-color: red">
      <span>Não Autorizar</span>
    </button>
</form>
</div>
{% endblock content %}

reservation/templates/reservation/event/event_create.html
{% extends "../base.html" %} 
{% block header %}
Reservas - Criar Evento
{% endblock header %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Pre_Agendar.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">CRIAR EVENTO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">DURAÇÃO</span>
        <select class="select" name="duration" id="id_duration">
            <option value="2">2 horas</option>
            <option value="4">4 horas</option>
            <option value="6">6 horas</option>
            <option value="8">8 horas</option>
            <option value="10">10 horas</option>
            <option value="12">12 horas</option>
            <option value="14">14 horas</option>
        </select>
      </div>
      <div class="field">
        <span class="field__text">NOME</span>
        <input type="text" name="name" required id="id_name" />
      </div>
      <div class="field">
        <span class="field__text">DATA</span>
        <input type="date" name="date" required id="id_date" />
      </div>
      <div class="field">
        <span class="field__text">HORÁRIO</span>
        <input type="time" name="time" required id="id_time" />
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/event/event_detail.html
{% extends "../base.html" %}
{% block header %}
Reservas - Visualizar Evento
{% endblock header %}
{% block content %}
<div class="content-detail">
    <table class="detail-table">
        <tr class="table-row">
            <th class="table-header">Nome:</th>
            <td class="table-data">{{object.name}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Data:</th>
            <td class="table-data">{{event_date}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Hora:</th>
            <td class="table-data">{{event_time}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Duração:</th>
            <td class="table-data">{{object.duration}} horas</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Status:</th>
            <td class="table-data">{{object.status}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Equipamentos:</th>
            <td class="table-data">
                {% for equipment in equipments %}
                    <span>{{ equipment.name }}</span>
                {% endfor %}
            </td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Sala:</th>
            <td class="table-data">{{object.classroom.id}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Usuário:</th>
            <td class="table-data">{{object.responsible.email}}</td>
        </tr>
    </table>
    <div class="flex-row">
        <a href="{% url 'event-equipment' object.classroom.id object.id %}" style="display: inline;">
            <button class="delete-button">
                <span>ADICIONAR EQUIPAMENTO</span>
            </button>
        </a>
        <a href="{% url 'classroom-event-update' event.classroom.id event.id %}" style="display: inline;">
            <button class="delete-button">
                <span>Atualizar</span>
            </button>
        </a>
        <form action="{% url 'classroom-event-delete' event.classroom.id event.id %}" method="post" style="display: inline;">
            {% csrf_token %}
            <input type="hidden" name="event_id" value="{{ event.pk }}"/>
            <button type="submit" class="delete-button">
                <span>Delete</span>
            </button>
        </form>
    </div>
</div>
{% endblock content %}
    

reservation/templates/reservation/event/event_list.html
{% extends "../base.html" %}
{% block header %}
Reservas - Lista de Eventos
{% endblock header %}
{% block content %}
{% load static %}
<div class="content-list">
    <div class="list-button">
        <button>
            <a href="{% url 'classroom-event-create' classroom.id %}">Criar</a>
        </button>
        <button>
            <a href="{% url 'pre-schedule' classroom.id %}">Pré-Agendar</a>
        </button>
        <button>
            <a href="{% url 'reservate' classroom.id %}">Reservar</a>
        </button>
    </div>
    <table class="list-table">
        <thead class="table-header">
            <tr>
                <th class="header__item">Nome</th>
                <th class="header__item">Data</th>
                <th class="header__item">Responsável</th>
            </tr>
        </thead>
        <tbody class="table-content">
            {% for event, date, time in Events %}
            <tr class="table-row">
                <td class="table-data">{{ event.name }}</td>
                <td class="table-data">{{ date }} às {{ time }}</td>
                <td class="table-data">{{ event.responsible }}</td>
                <td class="table-data">
                    <a class="link" href="{% url 'classroom-event' event.classroom.id event.id %}">Detalhes</a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</div>
{% endblock content %}

reservation/templates/reservation/event/event_reservate.html
{% extends "../base.html" %} 
{% block header %}
Reservas - Reservar Evento
{% endblock header %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Pre_Agendar.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">RESERVAR EVENTO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">DURAÇÃO</span>
        <select class="select" name="duration" id="id_duration">
            <option value="2">2 horas</option>
            <option value="4">4 horas</option>
            <option value="6">6 horas</option>
            <option value="8">8 horas</option>
            <option value="10">10 horas</option>
            <option value="12">12 horas</option>
            <option value="14">14 horas</option>
        </select>
      </div>
      <div class="field">
        <span class="field__text">NOME</span>
        <input type="text" name="name" required id="id_name" />
      </div>
      <div class="field">
        <span class="field__text">DATA</span>
        <input type="date" name="date" required id="id_date" />
      </div>
      <div class="field">
        <span class="field__text">HORÁRIO</span>
        <input type="time" name="time" required id="id_time" />
      </div>
      <div class="field">
        <span class="field__text">DATA LIMITE</span>
        <input type="date" name="limit_date" required id="id_limit_date" />
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/event/event_update.html
{% extends "../base.html" %} 
{% block header %}
Reservas - Atualizar Evento
{% endblock header %}
{% block content %}
<div class="content-create">
  <div class="content__icon">
    {% load static %}
    <object data="{% static '/images/Pre_Agendar.svg' %}"></object>
    <div class="icon-add">+</div>
    <span class="icon-text">ATUALIZAR EVENTO</span>
  </div>
  <form class="form" method="post">
    {% csrf_token %}
    <div class="form__fields">
      <div class="field">
        <span class="field__text">DURAÇÃO</span>
        <select class="select" name="duration" id="id_duration">
            <option value="{{ object.duration }}">Valor antigo: {{ object.duration }} horas</option>
            <option value="2">2 horas</option>
            <option value="4">4 horas</option>
            <option value="6">6 horas</option>
            <option value="8">8 horas</option>
            <option value="10">10 horas</option>
            <option value="12">12 horas</option>
            <option value="14">14 horas</option>
        </select>
      </div>
      <div class="field">
        <span class="field__text">DATA</span>
        <input value="{{ date }}" type="date" name="date" required id="id_date" />
      </div>
      <div class="field">
        <span class="field__text">HORÁRIO</span>
        <input value="{{ time }}" type="time" name="time" required id="id_time" />
      </div>
    </div>
    <button class="button" type="submit">
      <span>SALVAR</span>
      <div class="button-add">+</div>
    </button>
  </form>
</div>
{% endblock content %}

reservation/templates/reservation/event/unauthorized_event_detail.html
{% extends "../base.html" %}
{% block header %}
Reservas - Eventos Não Autorizados
{% endblock header %}
{% block content %}
<div class="content-detail">
    <table class="detail-table">
        <tr class="table-row">
            <th class="table-header">Nome:</th>
            <td class="table-data">{{object.name}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Data:</th>
            <td class="table-data">{{event_date}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Hora:</th>
            <td class="table-data">{{event_time}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Duração:</th>
            <td class="table-data">{{object.duration}} horas</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Status:</th>
            <td class="table-data">{{object.status}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Equipamentos:</th>
            <td class="table-data">
                {% for equipment in equipments %}
                    <span>{{ equipment.name }}</span>
                {% endfor %}
            </td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Sala:</th>
            <td class="table-data">{{object.classroom.id}}</td>
        </tr>
        <tr class="table-row">
            <th class="table-header">Usuário:</th>
            <td class="table-data">{{object.responsible.email}}</td>
        </tr>
    </table>
    <div class="flex-row">
        <a href="{% url 'authorize' object.id %}" style="display: inline;">
            <button class="delete-button">
                <span>Autorizar</span>
            </button>
        </a>
        <a href="{% url 'event-update' pk=event.id %}" style="display: inline;">
            <button class="delete-button">
                <span>Atualizar</span>
            </button>
        </a>
        <form action="{% url 'event-delete' event.id %}" method="post" style="display: inline;">
            {% csrf_token %}
            <input type="hidden" name="event_id" value="{{ event.pk }}"/>
            <button type="submit" class="delete-button">
                <span>Delete</span>
            </button>
        </form>
    </div>
</div>
{% endblock content %}
    

reservation/templates/reservation/event/unauthorized_event_list.html
{% extends "../base.html" %}
{% block header %}
Reservas - Eventos Não Autorizados
{% endblock header %}
{% block content %}
{% load static %}
<div class="content-list">
    <table class="list-table">
        <thead class="table-header">
            <tr>
                <th class="header__item">Nome</th>
                <th class="header__item">Data</th>
                <th class="header__item">Responsável</th>
            </tr>
        </thead>
        <tbody class="table-content">
            {% for event, date, time in Events %}
            <tr class="table-row">
                <td class="table-data">{{ event.name }}</td>
                <td class="table-data">{{ date }} às {{ time }}</td>
                <td class="table-data">{{ event.responsible }}</td>
                <td class="table-data">
                    <a class="link" href="{% url 'event-detail' event.id %}">Detalhes</a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</div>
{% endblock content %}